Subject: Re: bug#38523: 27.0.50; tab-line faces don't update to reflect selected tab

From: Juri Linkov <[email-masked]>
Date: Wed, 23 Dec 2020 23:08:30 +0200

>> The following change seems to make the tab faces update properly after clicking a
>> tab. But I'm not sure this is the correct way to do it.
>
> [...]
>
>>  +        (progn
>>  +          (tab-line-select-tab-buffer buffer (posn-window posnp))
>>  +          (force-mode-line-update t)
>>  +          (set-window-parameter nil 'tab-line-cache nil)
>>  +          (setf tab-line-format '(:eval (tab-line-format)))
>
> No, I have a feeling that may be too heavy-handed.
>
>>  I configured the tab bar and tab line faces (tab-bar-tab and
>>  tab-line-tab-current) to show the currently selected tab with yellow text.
>>
>>  Although the tab __bar__ faces do update properly to highlight the
>>  selected tab, the tab __line__ faces don't update; no matter which is
>>  clicked, the first tab that had been highlighted stays highlighted
>>  (or sometimes none of them are highlighted.) Also, the close buttons
>>  on tab line tabs do not work; instead it just switches to that tab's
>>  buffer.
>
> Perhaps Juri has some insight here (added to the Cc).

Sorry for the delay.  Now I pushed to master a patch from emacs-devel
that improves tab-line face calculation logic.

David, could you please confirm if everything works correctly now.